// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/ThrottleInfo.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/throttle_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `accel_pedal_qf`
#include "ds_dbw_msgs/msg/detail/quality__functions.h"
// Member `one_pedal`
#include "ds_dbw_msgs/msg/detail/one_pedal__functions.h"
// Member `drive_mode`
#include "ds_dbw_msgs/msg/detail/drive_mode__functions.h"
// Member `gear_num`
#include "ds_dbw_msgs/msg/detail/gear_num__functions.h"

bool
ds_dbw_msgs__msg__ThrottleInfo__init(ds_dbw_msgs__msg__ThrottleInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
    return false;
  }
  // accel_pedal_pc
  // accel_pedal_qf
  if (!ds_dbw_msgs__msg__Quality__init(&msg->accel_pedal_qf)) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
    return false;
  }
  // one_pedal
  if (!ds_dbw_msgs__msg__OnePedal__init(&msg->one_pedal)) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
    return false;
  }
  // engine_rpm
  // drive_mode
  if (!ds_dbw_msgs__msg__DriveMode__init(&msg->drive_mode)) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
    return false;
  }
  // gear_num
  if (!ds_dbw_msgs__msg__GearNum__init(&msg->gear_num)) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
    return false;
  }
  return true;
}

void
ds_dbw_msgs__msg__ThrottleInfo__fini(ds_dbw_msgs__msg__ThrottleInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // accel_pedal_pc
  // accel_pedal_qf
  ds_dbw_msgs__msg__Quality__fini(&msg->accel_pedal_qf);
  // one_pedal
  ds_dbw_msgs__msg__OnePedal__fini(&msg->one_pedal);
  // engine_rpm
  // drive_mode
  ds_dbw_msgs__msg__DriveMode__fini(&msg->drive_mode);
  // gear_num
  ds_dbw_msgs__msg__GearNum__fini(&msg->gear_num);
}

bool
ds_dbw_msgs__msg__ThrottleInfo__are_equal(const ds_dbw_msgs__msg__ThrottleInfo * lhs, const ds_dbw_msgs__msg__ThrottleInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // accel_pedal_pc
  if (lhs->accel_pedal_pc != rhs->accel_pedal_pc) {
    return false;
  }
  // accel_pedal_qf
  if (!ds_dbw_msgs__msg__Quality__are_equal(
      &(lhs->accel_pedal_qf), &(rhs->accel_pedal_qf)))
  {
    return false;
  }
  // one_pedal
  if (!ds_dbw_msgs__msg__OnePedal__are_equal(
      &(lhs->one_pedal), &(rhs->one_pedal)))
  {
    return false;
  }
  // engine_rpm
  if (lhs->engine_rpm != rhs->engine_rpm) {
    return false;
  }
  // drive_mode
  if (!ds_dbw_msgs__msg__DriveMode__are_equal(
      &(lhs->drive_mode), &(rhs->drive_mode)))
  {
    return false;
  }
  // gear_num
  if (!ds_dbw_msgs__msg__GearNum__are_equal(
      &(lhs->gear_num), &(rhs->gear_num)))
  {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__ThrottleInfo__copy(
  const ds_dbw_msgs__msg__ThrottleInfo * input,
  ds_dbw_msgs__msg__ThrottleInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // accel_pedal_pc
  output->accel_pedal_pc = input->accel_pedal_pc;
  // accel_pedal_qf
  if (!ds_dbw_msgs__msg__Quality__copy(
      &(input->accel_pedal_qf), &(output->accel_pedal_qf)))
  {
    return false;
  }
  // one_pedal
  if (!ds_dbw_msgs__msg__OnePedal__copy(
      &(input->one_pedal), &(output->one_pedal)))
  {
    return false;
  }
  // engine_rpm
  output->engine_rpm = input->engine_rpm;
  // drive_mode
  if (!ds_dbw_msgs__msg__DriveMode__copy(
      &(input->drive_mode), &(output->drive_mode)))
  {
    return false;
  }
  // gear_num
  if (!ds_dbw_msgs__msg__GearNum__copy(
      &(input->gear_num), &(output->gear_num)))
  {
    return false;
  }
  return true;
}

ds_dbw_msgs__msg__ThrottleInfo *
ds_dbw_msgs__msg__ThrottleInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__ThrottleInfo * msg = (ds_dbw_msgs__msg__ThrottleInfo *)allocator.allocate(sizeof(ds_dbw_msgs__msg__ThrottleInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__ThrottleInfo));
  bool success = ds_dbw_msgs__msg__ThrottleInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__ThrottleInfo__destroy(ds_dbw_msgs__msg__ThrottleInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__ThrottleInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__ThrottleInfo__Sequence__init(ds_dbw_msgs__msg__ThrottleInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__ThrottleInfo * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__ThrottleInfo *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__ThrottleInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__ThrottleInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__ThrottleInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__ThrottleInfo__Sequence__fini(ds_dbw_msgs__msg__ThrottleInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__ThrottleInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__ThrottleInfo__Sequence *
ds_dbw_msgs__msg__ThrottleInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__ThrottleInfo__Sequence * array = (ds_dbw_msgs__msg__ThrottleInfo__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__ThrottleInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__ThrottleInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__ThrottleInfo__Sequence__destroy(ds_dbw_msgs__msg__ThrottleInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__ThrottleInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__ThrottleInfo__Sequence__are_equal(const ds_dbw_msgs__msg__ThrottleInfo__Sequence * lhs, const ds_dbw_msgs__msg__ThrottleInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__ThrottleInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__ThrottleInfo__Sequence__copy(
  const ds_dbw_msgs__msg__ThrottleInfo__Sequence * input,
  ds_dbw_msgs__msg__ThrottleInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__ThrottleInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__ThrottleInfo * data =
      (ds_dbw_msgs__msg__ThrottleInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__ThrottleInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__ThrottleInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__ThrottleInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
